﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace DSwav2c
{
    public partial class Form1 : Form
    {

        WaveManager WManager;
        String OpeningFileName;

        public Form1()
        {
            InitializeComponent();

            WManager = new WaveManager();

            LabelWavBit.Text = "";
            LabelWavMono.Text = "";
            LabelWavSample.Text = "";
            LabelWavSize.Text = "";
            LabelFileName.Text = "";

        }

        private void OpenButton_Click(object sender, EventArgs e)
        {
            //ファイルを開く
            OpenFileDialog aForm = new OpenFileDialog();
            aForm.CheckFileExists = true;
            aForm.Filter = "Wave file(*.wav)|*.wav|All files(*.*)|*.*";

            //押されたボタン別の処理 
            if (aForm.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                CTextBox.Text = WManager.LoadAndGenerate(aForm.FileName, System.IO.Path.GetFileNameWithoutExtension(aForm.FileName));
                OpeningFileName = System.IO.Path.GetFileNameWithoutExtension(aForm.FileName);

                LabelWavBit.Text = WManager.Header.bit.ToString() + "bit";
                LabelWavMono.Text = WManager.Header.channels == 1 ? "Mono" : "Stereo";
                LabelWavSample.Text = WManager.Header.sampleRate.ToString() + "Hz";
                LabelWavSize.Text = (WManager.Header.dataSize / WManager.Header.blockSize).ToString() +"samples";
                LabelFileName.Text = System.IO.Path.GetFileName(aForm.FileName);


            }

            aForm.Dispose();

        }

        private void SaveButton_Click(object sender, EventArgs e)
        {
            SaveFileDialog aForm = new SaveFileDialog();
            aForm.OverwritePrompt = true;
            aForm.Filter = "C header file(*.h)|*.h|All files(*.*)|*.*";
            aForm.FileName = OpeningFileName;

            //押されたボタン別の処理 
            if (aForm.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                CTextBox.SaveFile(aForm.FileName, RichTextBoxStreamType.PlainText);
            }

            aForm.Dispose();
        }
    }
}
